/***************************************************************
 * Name:      choice.h
 * Purpose:   Defines Dialog choice
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-26
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef CHOICE_H
#define CHOICE_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <wx/validate.h>

class datosChoice
{
    public:
        datosChoice() {}
        datosChoice(wxString valor) {
            opcion = valor;
        }

    //private:
        wxString opcion;
};

class chValidator : public wxValidator {
public:
    chValidator(wxString *v = nullptr);
    virtual wxObject* Clone() const { return new chValidator(*this); }
    virtual bool TransferFromWindow();
    virtual bool TransferToWindow();
    virtual bool Validate(wxWindow * parent);
private:
    wxString* m_valor;
    DECLARE_DYNAMIC_CLASS( chValidator )
    DECLARE_EVENT_TABLE()
};

class choice : public wxDialog
{
    public:
        choice(wxWindow *wnd, datosChoice &datos);
        virtual ~choice();

    protected:
        enum
        {
            idChoice = 1000
        };
        datosChoice& data;
        wxChoice* m_choice;

    private:
        void OnClose(wxCloseEvent& event);
        wxDECLARE_EVENT_TABLE();
};

#endif // CHOICE_H
