/***************************************************************
 * Name:      cliendata.h
 * Purpose:   Defines Dialog listbox con clientdata
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-24
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef CLIENDATA_H
#define CLIENDATA_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <vector>
#include <wx/validate.h>

class datosClientData
{
    public:
        datosClientData() {}
        datosClientData(wxUint32 valor) {
            opcion = valor;
        }

    //private:
        wxUint32 opcion;
};

struct tipoOpcion {
    wxString nombre;
    wxUint32 rgb;
};

class cdValidator : public wxValidator {
public:
    cdValidator(wxUint32 *v = nullptr) :
         wxValidator(), m_valor(v) {}

    virtual wxObject* Clone() const { return new cdValidator(*this); }
    virtual bool TransferFromWindow();
    virtual bool TransferToWindow();
    virtual bool Validate(wxWindow * parent);
private:
    wxUint32* m_valor;
    DECLARE_DYNAMIC_CLASS( cdValidator )
    DECLARE_EVENT_TABLE()
};

class colorClientData : public wxClientData {
public:
    colorClientData(wxUint32 v=0) : m_color(v) {}
    wxUint32 GetData() const { return m_color; }
    void SetData(wxUint32 v) { m_color=v; }

private:
    wxUint32 m_color;
};

class cliendata : public wxDialog
{
    public:
        cliendata(wxWindow *wnd, datosClientData &datos);
        virtual ~cliendata();

    protected:
        enum
        {
            idListBox = 1000
        };
        datosClientData& data;
        wxListBox* m_listBox;

    private:
        void OnClose(wxCloseEvent& event);
        wxDECLARE_EVENT_TABLE();
};

#endif // CLIENDATA_H
