/***************************************************************
 * Name:      listbox.h
 * Purpose:   Defines Dialog listbox
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-23
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef LISTBOX_H
#define LISTBOX_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <wx/validate.h>

class datosListBox
{
    public:
        datosListBox() {}
        datosListBox(wxString valor) {
            opcion = valor;
        }

    //private:
        wxString opcion;
};

class lbValidator : public wxValidator {
public:
    lbValidator(wxString *v = nullptr);
    virtual wxObject* Clone() const { return new lbValidator(*this); }
    virtual bool TransferFromWindow();
    virtual bool TransferToWindow();
    virtual bool Validate(wxWindow * parent);
private:
    wxString* m_valor;
    DECLARE_DYNAMIC_CLASS( lbValidator )
    DECLARE_EVENT_TABLE()
};

class listbox : public wxDialog
{
    public:
        listbox(wxWindow *wnd, datosListBox &datos);
        virtual ~listbox();

    protected:
        enum
        {
            idListBox = 1000
        };
        datosListBox& data;
        wxListBox* m_listBox;

    private:
        void OnClose(wxCloseEvent& event);
        wxDECLARE_EVENT_TABLE();
};
#endif // LISTBOX_H
