/***************************************************************
 * Name:      multiple.h
 * Purpose:   Defines Dialog listbox de selección múltiple
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-24
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef MULTIPLE_H
#define MULTIPLE_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <vector>
#include <wx/validate.h>

class datosMultiple
{
    public:
        datosMultiple() {}
        datosMultiple(wxArrayInt o) {
            opciones = o;
        }

    //private:
        wxArrayInt opciones;
};

struct tipoOpcionMultiple {
    wxString nombre;
    int clave;
};

class mulValidator : public wxValidator {
public:
    mulValidator(wxArrayInt *v = nullptr) :
         wxValidator(), m_valores(v) {}

    virtual wxObject* Clone() const { return new mulValidator(*this); }
    virtual bool TransferFromWindow();
    virtual bool TransferToWindow();
    virtual bool Validate(wxWindow * parent);
private:
    wxArrayInt* m_valores;
    DECLARE_DYNAMIC_CLASS( mulValidator )
    DECLARE_EVENT_TABLE()
};

class multipleClientData : public wxClientData {
public:
    multipleClientData(int v=0) : m_clave(v) {}
    int GetData() const { return m_clave; }
    void SetData(int v) { m_clave=v; }

private:
    int m_clave;
};

class multiple : public wxDialog
{
    public:
        multiple(wxWindow *wnd, datosMultiple &datos);
        virtual ~multiple();

    protected:
        enum
        {
            idListBox = 1000
        };
        datosMultiple& data;
        wxListBox* m_listBox;

    private:
        void OnClose(wxCloseEvent& event);
        wxDECLARE_EVENT_TABLE();
};

#endif // MULTIPLE_H
