/***************************************************************
 * Name:      wx008Main.h
 * Purpose:   Defines Application Frame
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-23
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifndef WX008MAIN_H
#define WX008MAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "wx008App.h"
#include "listbox.h"
#include "cliendata.h"
#include "multiple.h"
#include "choice.h"

class wx008Frame: public wxFrame
{
    public:
        wx008Frame(wxFrame *frame, const wxString& title);
        ~wx008Frame();
    private:
        enum
        {
            idMenuQuit = 1000,
            idMenuAbout,
            idMenuListBox,
            idMenuClientData,
            idMenuMultiple,
            idMenuChoice
        };
        datosListBox dataListBox;
        datosClientData dataClientData;
        datosMultiple dataMultiple;
        datosChoice dataChoice;
        void OnClose(wxCloseEvent& event);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnListBox(wxCommandEvent& event);
        void OnClientData(wxCommandEvent& event);
        void OnMultiple(wxCommandEvent& event);
        void OnChoice(wxCommandEvent& event);
        DECLARE_EVENT_TABLE()
};

#endif // WX008MAIN_H
